/* ATHREAD.C */

#include <stdlib.h>
#include <assert.h>
#include <setjmp.h>
#include <string.h>
#include "err_sys.h"
#include "athread.h"
#define YES 1
#define NO  0

static thread *threads;

static int thcurr = 0;
static int n_threads;
static int Free ;
static char *stack;
static void (*Root)();
static int bool = 1;

void thprobe() {
 char p;
 if(threads[thcurr].stack >= &p) {
     err_sys("Stack overflow");
 }
}

thread *thinit(int n,unsigned int size)
{
int i;

 if(bool){
     bool = 0;
     if(n < 2) {
          return (thread *)0;
     }
     threads = (thread *)malloc(n * sizeof(thread));
     if(!threads) {
          return threads;
     }
     threads[0].parent = -1;
     threads[0].id = 1;
     threads[0].nchild = 0;
     threads[0].free = NO;
     threads[0].next = 0;
     for(i = 1; i < n ;i++) {
          threads[i].parent = 0;
          threads[i].id = i+1;
          threads[i].nchild = 0;
          threads[i].free = YES;
          threads[i].next = 0;
     }
     n_threads =  n -1 ;
     n = 0;
     stack = (char *)&size;
     if(setjmp(threads[0].exit))
          exit(0);
 } else if(!stack){
     stack = (char *)&size;
     if(setjmp(threads[n].exec)){  /*exec n  */
          if(!setjmp(threads[thcurr].exit))
               (*Root)();
          threads[thcurr].free = YES;   /*exit for thcurr */
          for(i = 0; i <= n_threads ; i++){
               if(threads[i].parent == thcurr)
                    threads[i].parent = threads[thcurr].parent;
          }
          Free = threads[thcurr].id;
          thcurr = threads[thcurr].parent;
          longjmp(threads[thcurr].jump,Free);
     }
 }

/* make space inside stack */

if((unsigned int)(stack - (char *)&size) < size)
     thinit(n,size);
else {
     threads[n].stack = (char *)&size;
     stack = 0;
     if(n < n_threads)
          thinit(++n,size);
      }
  return threads;
}

void thfree()
{
 if(threads!=0) {
     free(threads);
     threads = 0;
     n_threads = 0;
 }
}

int thnew(void (*root)())
{
int parent ;
int fork;

thprobe();
for(fork = 0; fork <= n_threads ; fork++){
     if(threads[fork].free == YES)
          break;
     }
if(threads[fork].free == NO)
     return -1;
threads[fork].next = thcurr;
threads[fork].parent = thcurr;
threads[fork].free = NO;
threads[fork].nchild = 0;
threads[thcurr].nchild++;
threads[thcurr].next = fork;
parent = thcurr;
thcurr = fork;
if(setjmp(threads[parent].jump))
     return fork;
Root = root;
longjmp(threads[thcurr].exec,parent+1);
}

void thexit()
{
thprobe();
longjmp(threads[thcurr].exit,threads[thcurr].id);
}

int thjump(int id)
{
int jumper;
int caller;
int ret;

thprobe();
if(id < 0 || id > n_threads)
     return -1;
if(threads[id].free == YES)
     return -1;
caller = thcurr;
if(id == caller)
     return thcurr;
ret = threads[thcurr].id;
thcurr = id;
if(jumper = setjmp(threads[caller].jump))
     return jumper;
longjmp(threads[id].jump,ret);
}

pid()
{
return thcurr;
}

ppid()
{
return threads[thcurr].parent;
}


#define MAXMESSAGES 20
static message_t messbuf[MAXMESSAGES];

int message_snd(int id,unsigned count , void *s)
{
int i;

if(count >= MAX_MESSAGE_LEN)
	return OVR_ERROR;

for(i = 0; i < MAXMESSAGES ; i++)
     if(messbuf[i].flag == 0){
          messbuf[i].spid = pid();
          messbuf[i].rpid = id;
          messbuf[i].count = count;
          memcpy(messbuf[i].s , s,count);
		  messbuf[i].flag = 1;
          return OVR_OK;
          }
return OVR_ERROR;
}

message_t *message_rcv()
{
int i;
int p = pid();

for(i = 0;i < MAXMESSAGES ;i++)
     if(p == messbuf[i].rpid && messbuf[i].flag == 1){
          messbuf[i].flag = 0;
          return &(messbuf[i]);
          }
return 0;
}
