/* like.h */
#ifndef _LIKE_H
#define _LIKE_H

#include "header.h"

/* Hmm, separate char and uni_char versions... Template would be
   handy to have here... */

/* Immediately test whether "string" matches "pattern" */
bool string_like(const char *string, const char *pattern, char escape);
bool uni_string_like(const uni_char *string, const uni_char *pattern, uni_char escape);

/* Preprocess pattern and use it to recognize the "string" */
const void* pattern_to_dfa(const char *pattern, char escape);
bool string_recognized_by_dfa(const void* d, const char *string);
const void* uni_pattern_to_dfa(const uni_char *pattern, uni_char escape);
bool uni_string_recognized_by_dfa(const void* d, const uni_char *string);
void free_dfa(const void *d);

#endif
